$(document).ready(function(){
	//brand click info box
	$('.brand').click(function(){
		$('#modal_info').modal('show');
	});

	$('#reload_state').click(function(){
		set_online_state();
	});
	
	//disbaling some functions for Internet Explorer
	if($.browser.msie)
	{
		$('#for-is-ajax').hide();
		$('#toggle-fullscreen').hide();
	}
	
	
	//highlight current / active link
	$('ul.main-menu li a').each(function(){
		if($($(this))[0].href==String(window.location))
			$(this).parent().addClass('active');
	});
	

	var History = window.History, // Note: We are using a capital H instead of a lower h
	State = History.getState();

	//bind to State Change
	History.Adapter.bind(window,'statechange',function(){ // Note: We are using statechange instead of popstate
		var State = History.getState(); // Note: We are using History.getState() instead of event.state
		$.ajax({
			url:State.url,
			success:function(msg){
				$('#content').html($(msg).find('#content').html());
				$('#loading').remove();
				$('#content').fadeIn();
				docReady();
			}
		});
	});


	// user document.on so that content loaded via ajax also gets the "ajax click" behaviour
	$(document).on('click', 'a.ajax-link', function(e){
		console.log('fire ajax call');
		if($.browser.msie) e.which=1;
		if(e.which!=1){ console.log('No ajax with ie'); return; }

		e.preventDefault();
		e.stopPropagation();

		$('#loading').remove();
		$('#content').fadeOut().parent().append('<div id="loading" class="center">Loading...<div class="center"></div></div>');

		History.pushState(null, null, this.href);
		$('ul.main-menu li.active').removeClass('active');
		$('ul.main-menu li a').each(function(){
			if($($(this))[0].href==String(window.location))
				$(this).parent().addClass('active');
		});

		$.ajax({
			url: this.href,
			success:function(msg){
				$('#content').html($(msg).find('#content').html());
				$('#loading').remove();
				$('#content').fadeIn();
				docReady();
				return false;
			},
			error:function (xhr, ajaxOptions, thrownError){
				console.log(xhr.status);
				console.log(xhr.statusText);
				console.log(xhr.responseText);
				if(xhr.status == '404'){
					alert('Page was not found [404], redirecting to dashboard.');
					window.location.href = "index.php";
				}
			}
		});

		return true;
	});
	
	//animating menus on hover
	$('ul.main-menu li:not(.nav-header)').hover(function(){
		$(this).animate({'margin-left':'+=5'},300);
	},
	function(){
		$(this).animate({'margin-left':'-=5'},300);
	});

	//other things to do on document ready, seperated for ajax calls
	docReady();
});


function docReady(){
	players_initialized = 0;
	player_list = '';

	set_avatars();
	set_online_state();

	//resize iframe
	if($('#map_frame').length != 0){
		$('#map_frame').css('height', $(window).height());
	}

	//prevent # links from moving to top
	$('a[href="#"][data-top!=true]').click(function(e){
		e.preventDefault();
	});
	
	//datepicker
	$('.datepicker').datepicker();
	
	//notifications
	$('.noty').click(function(e){
		e.preventDefault();
		var options = $.parseJSON($(this).attr('data-noty-options'));
		noty(options);
	});


	//uniform - styler for checkbox, radio and file input
	$("input:checkbox, input:radio, input:file").not('[data-no-uniform="true"],#uniform-is-ajax').uniform();

	//chosen - improves select
	$('[data-rel="chosen"],[rel="chosen"]').chosen();


	//makes elements soratble, elements that sort need to have id attribute to save the result
	$('.sortable').sortable({
		revert:true,
		cancel:'.btn,.box-content,.nav-header',
		update:function(event,ui){
			//line below gives the ids of elements, you can make ajax call here to save it to the database
			//console.log($(this).sortable('toArray'));
		}
	});

	//slider
	$('.slider').slider({range:true,values:[10,65]});

	//tooltip
	$('[rel="tooltip"],[data-rel="tooltip"]').tooltip({"placement":"bottom",delay: { show: 400, hide: 200 }});

	//datatable
	$('.datatable').dataTable({
			"sDom": "<'row-fluid'<'span6'l><'span6'f>r>t<'row-fluid'<'span12'i><'span12 center'p>>",
			"sPaginationType": "bootstrap",
			"bProcessing": true,
			"oLanguage": {
			"sLengthMenu": "_MENU_ records per page"
			}
		} );
	$('.btn-close').click(function(e){
		e.preventDefault();
		$(this).parent().parent().parent().fadeOut();
	});
	$('.btn-minimize').click(function(e){
		e.preventDefault();
		var $target = $(this).parent().parent().next('.box-content');
		if($target.is(':visible')) $('i',$(this)).removeClass('icon-chevron-up').addClass('icon-chevron-down');
		else 					   $('i',$(this)).removeClass('icon-chevron-down').addClass('icon-chevron-up');
		$target.slideToggle();
	});
	$('.btn-setting').click(function(e){
		e.preventDefault();
		$('#myModal').modal('show');
	});


	//players overview datatable
	$('.ajax-datatable').dataTable({
			"sDom": "<'row-fluid'<'span6'l><'span6'f>r>t<'row-fluid'<'span12'i><'span12 center'p>>",
			"sPaginationType": "bootstrap",
			"bProcessing": true,
			"bServerSide": true,
			"fnInitComplete": function(oSettings, json) {
				//$('.dataTables_processing').addClass('btn btn-large btn-primary');
				//noty({"text":"This is an error notification","layout":"center","type":"error"});
    		},
    		"fnDrawCallback": function( oSettings ) {
    			set_avatars();
    			set_online_state();
    		},
			"sAjaxSource": "ajax_player_table.php",
			"oLanguage": {
				"sLengthMenu": "_MENU_ records per page"
			}
	} );

	if($("#load_charts").length){
		$.getScript("ajax_charts.php?p="+$('#player_id').html());
	}

	console.log('everything loaded');
}


//additional functions for data table
$.fn.dataTableExt.oApi.fnPagingInfo = function ( oSettings )
{
	return {
		"iStart":         oSettings._iDisplayStart,
		"iEnd":           oSettings.fnDisplayEnd(),
		"iLength":        oSettings._iDisplayLength,
		"iTotal":         oSettings.fnRecordsTotal(),
		"iFilteredTotal": oSettings.fnRecordsDisplay(),
		"iPage":          Math.ceil( oSettings._iDisplayStart / oSettings._iDisplayLength ),
		"iTotalPages":    Math.ceil( oSettings.fnRecordsDisplay() / oSettings._iDisplayLength )
	};
}
$.extend( $.fn.dataTableExt.oPagination, {
	"bootstrap": {
		"fnInit": function( oSettings, nPaging, fnDraw ) {
			var oLang = oSettings.oLanguage.oPaginate;
			var fnClickHandler = function ( e ) {
				e.preventDefault();
				if ( oSettings.oApi._fnPageChange(oSettings, e.data.action) ) {
					fnDraw( oSettings );
				}
			};

			$(nPaging).addClass('pagination').append(
				'<ul>'+
					'<li class="prev disabled"><a href="#">&larr; '+oLang.sPrevious+'</a></li>'+
					'<li class="next disabled"><a href="#">'+oLang.sNext+' &rarr; </a></li>'+
				'</ul>'
			);
			var els = $('a', nPaging);
			$(els[0]).bind( 'click.DT', { action: "previous" }, fnClickHandler );
			$(els[1]).bind( 'click.DT', { action: "next" }, fnClickHandler );
		},

		"fnUpdate": function ( oSettings, fnDraw ) {
			var iListLength = 5;
			var oPaging = oSettings.oInstance.fnPagingInfo();
			var an = oSettings.aanFeatures.p;
			var i, j, sClass, iStart, iEnd, iHalf=Math.floor(iListLength/2);

			if ( oPaging.iTotalPages < iListLength) {
				iStart = 1;
				iEnd = oPaging.iTotalPages;
			}
			else if ( oPaging.iPage <= iHalf ) {
				iStart = 1;
				iEnd = iListLength;
			} else if ( oPaging.iPage >= (oPaging.iTotalPages-iHalf) ) {
				iStart = oPaging.iTotalPages - iListLength + 1;
				iEnd = oPaging.iTotalPages;
			} else {
				iStart = oPaging.iPage - iHalf + 1;
				iEnd = iStart + iListLength - 1;
			}

			for ( i=0, iLen=an.length ; i<iLen ; i++ ) {
				// remove the middle elements
				$('li:gt(0)', an[i]).filter(':not(:last)').remove();

				// add the new list items and their event handlers
				for ( j=iStart ; j<=iEnd ; j++ ) {
					sClass = (j==oPaging.iPage+1) ? 'class="active"' : '';
					$('<li '+sClass+'><a href="#">'+j+'</a></li>')
						.insertBefore( $('li:last', an[i])[0] )
						.bind('click', function (e) {
							e.preventDefault();
							oSettings._iDisplayStart = (parseInt($('a', this).text(),10)-1) * oPaging.iLength;
							fnDraw( oSettings );
						} );
				}

				// add / remove disabled classes from the static elements
				if ( oPaging.iPage === 0 ) {
					$('li:first', an[i]).addClass('disabled');
				} else {
					$('li:first', an[i]).removeClass('disabled');
				}

				if ( oPaging.iPage === oPaging.iTotalPages-1 || oPaging.iTotalPages === 0 ) {
					$('li:last', an[i]).addClass('disabled');
				} else {
					$('li:last', an[i]).removeClass('disabled');
				}
			}
		}
	}
});

function set_avatars(){
	if(activate_avatars == 1){
		player_list = '';

		$('.p_name').each(function(){
			player = $(this).children('a').html();
			$(this).html('<a class="ajax-link" data-rel="popover" data-content="<img src=\'https://minotar.net/avatar/'+player+'/256\'>" title="Avatar of '+player+'" href="single_player.php?p='+player+'"><img src="https://minotar.net/avatar/'+player+'/20"> '+player+' <span class="state_label state_'+player+'"></span></a>');
			player_list = player_list+player+', ';
		});

		players_initialized = 1;

		//initialize popovers
		$('[rel="popover"],[data-rel="popover"]').popover({
			container: '#content',
			placement: 'right'
		});
		//close popovers on click
		$('.popover').click(function(e){
			$(this).remove();
		});
	}
}

function set_online_state(){
	if(activate_online_state == 1){
		
		if(players_initialized == 0){
			player_list = '';

			$('.p_name').each(function(){
				player = $(this).children('a').html();
				$(this).html('<a class="ajax-link" href="single_player.php?p='+player+'">'+player+' <span class="state_label state_'+player+'"></span></a>');
				player_list = player_list+player+', ';
			});
		}

		$.ajax({
			url: 'ajax_players_state.php',
			type: "POST",
			data: {"player_list" : player_list},
			dataType: "json",
			success: function(data){
				$.each(data, function(key, val){
					if(val == 1){
						$('.state_'+key).html('<span class="label label-success">online</span>');
					} else {
						$('.state_'+key).html('<span class="label label-important">offline</span>');
					}
				})
			}
		});
	}
}